define(["dojo/_base/declare", "dojo/has", "dijit/form/FilteringSelect", "./ComboBoxVisBidi","dojox/string/BidiEngine"], 
		function(declare, has , select ,bidiCombo, BidiEngine){
	var bidiEngine = new BidiEngine(); 
	
	return declare("bidi.FilteringSelectVisBidi",[bidiCombo, select],{
	postCreate: function(){
		var visChForBidiFormat = (this.isVisualMode == true) ? "V" : "I";
		var dirChForBidiFormat = (this.dir == "rtl") ? "R" : "L";
		var str = bidiEngine.bidiTransform (this.invalidMessage, visChForBidiFormat + dirChForBidiFormat + "YNN", "I" + dirChForBidiFormat + "YNN");
		this.set("invalidMessage", str);
		str = bidiEngine.bidiTransform (this.placeHolder, visChForBidiFormat + dirChForBidiFormat + "YNN", "I" + dirChForBidiFormat + "YNN");
		this.set("placeHolder", str);
       	this.inherited(arguments);
        	
    },
	validate: function(isFocused){
		var tmpMarker = null;
		var fakedFocus = false;
		if(has("ie") && this.isVisualMode) {
			if (this.textbox.value.length > 0 && (this.textbox.value.charAt(0) == this.LRO || this.textbox.value.charAt(0) == this.RLO)){
				tmpMarker = this.textbox.value.charAt(0);
				this.textbox.value = this.textbox.value.substring(1);
			}
		}
		dijit.form.FilteringSelect.prototype.validate.apply(this, arguments)
		if(has("ie") && tmpMarker) {
			this.textbox.value = tmpMarker + this.textbox.value;
		}
	},
	isValid: function(isFocused){
		if (/*isFocused || */!((has("ie") && this.isVisualMode)))
			return this.inherited(arguments);   

		var options = this.store.data;    
		if (options == null)
                    options = this.store._itemsByIdentity;
                if (options == null)
                    options = this.store._jsonData; 
		if (options == null)
			return true;
                if (!this._hasBeenBlurred) {
			for (var k = 0; k < options.length; k++) {
				var text = options[k].name;
				text =  this.bidiTransform (text, "V" + this.dirChForBidiFormat + "YNN", "I" + this.dirChForBidiFormat + "YNN");
				if (text == this.textbox.value)
					return true;
			} 
		} else {
			for (var k = 0; k < options.length; k++) {
				var text = options[k].name;
				if (text == this.textbox.value)
					return true;
			} 
		}

		return false;
	},
	_setBlurValue: function(){
		var value = null;
		this.inherited(arguments);     
		if (value)
			this.set('displayedValue', value);
			
	}
	});
}); 
